Bug 1476593 - rpm: python3 build failure related to debuginfo extraction
Summary: rpm: python3 build failure related to debuginfo extraction
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: rpm
Version: 27
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Packaging Maintenance Team
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-07-30 15:10 UTC by Florian Weimer
Modified: 2018-11-30 22:17 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-30 22:17:50 UTC
Type: Bug


Attachments (Terms of Use)

Description Florian Weimer 2017-07-30 15:10:11 UTC
I have encountered a build failure due to debuginfo extraction:

  https://koji.fedoraproject.org/koji/taskinfo?taskID=20903200

Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Checking for unpackaged file(s): /usr/lib/rpm/check-files /builddir/build/BUILDROOT/python3-3.6.2-3.fc27.s390x
RPM build errors:
error: Installed (but unpackaged) file(s) found:
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.opt-1.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.opt-2.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.opt-1.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.opt-2.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.pyc
   /usr/lib/debug/usr/lib64/libpython3.6dm.so.1.0.debug-gdb.py
   /usr/lib/debug/usr/lib64/libpython3.6m.so.1.0.debug-gdb.py
    Duplicate build-ids /builddir/build/BUILDROOT/python3-3.6.2-3.fc27.s390x/usr/bin/python3.6 and /builddir/build/BUILDROOT/python3-3.6.2-3.fc27.s390x/usr/libexec/system-python
    File listed twice: /usr/lib/.build-id/94/cd86a8356e4dd936e193186805048cbee6e07e
    File listed twice: /usr/lib64/libpython3.6dm.so.1.0
    Duplicate build-ids /builddir/build/BUILDROOT/python3-3.6.2-3.fc27.s390x/usr/lib/debug/usr/bin/python3.6-3.6.2-3.fc27.s390x.debug and /builddir/build/BUILDROOT/python3-3.6.2-3.fc27.s390x/usr/lib/debug/usr/libexec/system-python-3.6.2-3.fc27.s390x.debug
    Installed (but unpackaged) file(s) found:
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.opt-1.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.opt-2.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6dm.so.1.0.debug-gdb.cpython-36.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.opt-1.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.opt-2.pyc
   /usr/lib/debug/usr/lib64/__pycache__/libpython3.6m.so.1.0.debug-gdb.cpython-36.pyc
   /usr/lib/debug/usr/lib64/libpython3.6dm.so.1.0.debug-gdb.py
   /usr/lib/debug/usr/lib64/libpython3.6m.so.1.0.debug-gdb.py
Child return code was: 1

This happened with rpm-build 4.13.0.1-40.fc27.

Comment 1 Mark Wielaard 2017-08-01 12:45:57 UTC
This is caused by split debuginfo checking which file corresponds to
which main/sub-package. Without split debuginfo anything found
under /usr/lib/debug is just put into the -debuginfo package, no
questions asked.

The immediate workaround is to add the following to your spec file:
%undefine _debuginfo_subpackages
(Which is what was done for python3-3.6.2-4.fc27)

This disables split debuginfo packages and just generates one big
-debuginfo packages with everything under /usr/lib/debug/ included.

But this might or might not be a packaging bug. In particular if it
contains generated pyc files those probably really shouldn't be there.

The basic issue is that we have been trying to make the debuginfo
packages self-contained and non-conflicting between versions.
So you can easily install debuginfo for different (bi)arches or
versions. But some packages assume that if they drop anything
under /usr/lib/debug it will just magically appear in the debuginfo
package (which has been historically true). But with the split
debuginfo we have to make a choice which subpackage it belongs
to. One possible rpm fix would probably be to add such files to the
"main" debuginfo package.

But it would probably be better to move these files to the
python3-devel package. Maybe we should discuss with the gdb
maintainers how/where they would like to see these gdb python
extensions installed. I doubt the -debuginfo package really is
the place for them anyway.

Comment 3 Jan Kurik 2017-08-15 08:41:46 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 27 development cycle.
Changing version to '27'.

Comment 4 Ben Cotton 2018-11-27 14:53:16 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 5 Ben Cotton 2018-11-30 22:17:50 UTC
Fedora 27 changed to end-of-life (EOL) status on 2018-11-30. Fedora 27 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.